package eu.mhsl.craftattack.worldmuseum.util;

import eu.mhsl.craftattack.worldmuseum.worlds.World;
import net.minestom.server.potion.Potion;
import net.minestom.server.potion.PotionEffect;
public class ChangeWorld {
    public static void changeWorld(NewPlayer player, World targetWorld) {
        player.setAllowMovement(false);
        World world = (World) player.getInstance();
        player.setAllowCompassUsage(false);
        player.addEffect(new Potion(PotionEffect.BLINDNESS, (byte) 0, 1000000));

        player.setRespawnPoint(targetWorld.getSpawn());
        player.setInstance(targetWorld, targetWorld.getSpawn()).thenRun(() -> {
            player.setAllowMovement(true);
            player.clearEffects();
            player.update_lastCompassUsage();
            player.setAllowCompassUsage(true);
        });
        assert world != null;
        System.out.println("[Worldchange] Player " + player.getUsername() + " changed world from " + world.getName() + " to " + targetWorld.getName() +".");
    }
}
