package eu.mhsl.craftattack.worldmuseum.util;

import eu.mhsl.craftattack.worldmuseum.worlds.World;
import eu.mhsl.craftattack.worldmuseum.worlds.WorldManager;
import net.kyori.adventure.text.Component;
import net.minestom.server.entity.Player;
import net.minestom.server.inventory.Inventory;
import net.minestom.server.inventory.InventoryType;
import net.minestom.server.item.Enchantment;
import net.minestom.server.item.ItemHideFlag;
import net.minestom.server.item.ItemStack;
import net.minestom.server.network.player.PlayerConnection;
import org.jetbrains.annotations.NotNull;
import org.jetbrains.annotations.Nullable;
import java.time.Duration;
import java.util.UUID;

public class NewPlayer extends Player {

    private boolean allowMovement = true;
    private long lastCompassUsage = 0;
    private boolean allowCompassUsage = true;

    public NewPlayer(@NotNull UUID uuid, @NotNull String username, @NotNull PlayerConnection playerConnection) {
        super(uuid, username, playerConnection);
    }
    public void setSyncCooldown(@Nullable Duration cooldown) {
        this.setCustomSynchronizationCooldown(cooldown);
    }

    public boolean isAllowMovement() {
        return allowMovement;
    }
    public void update_lastCompassUsage() {
        lastCompassUsage = System.currentTimeMillis();
    }
    public boolean isAllowCompassUsage() {
        long UsageDifference = System.currentTimeMillis() - lastCompassUsage;
        long difference = 15000; //in Milisec
        return UsageDifference >= difference && allowCompassUsage;
    }
    public void setAllowMovement(boolean allowMovement) {
        this.allowMovement = allowMovement;
    }
    public void setAllowCompassUsage(boolean allowCompassUsage) {
        this.allowCompassUsage = allowCompassUsage;
    }
    public long getLastCompassUsage() {
        return lastCompassUsage;
    }
    public Inventory getCompassInventory() {
        Inventory inventory = new Inventory(InventoryType.CHEST_1_ROW, Component.text("World-changer"));
        for (World w : WorldManager.getInstance().getWorlds()) {
            if (!w.equals(this.getInstance())) {
                inventory.addItemStack(w.getItem());
                continue;
            }
            ItemStack itemStack = ItemStack.builder(w.getItem().material())
                    .displayName(w.getItem().getDisplayName())
                    .meta(metaBuilder ->
                            metaBuilder
                                .enchantment(Enchantment.MENDING, (short) 10)
                                .hideFlag(ItemHideFlag.HIDE_ENCHANTS))
                    .build();
            inventory.addItemStack(itemStack);
        }
        return inventory;
    }

}
